# DataSource

## DikeDataSource\<T>

```typescript
abstract class DikeDataSource<T> extends DataSource<T> {

  constructor();
  
  abstract get data(): T[];
  abstract set data(value: T[]);

  abstract connect(): Observable<T[]>;
  abstract disconnect(): void;
  abstract reconnect(): void;

  abstract dispose(): void;
}
```

## DikeGridDataSource\<T>

```typescript
class DikeGridDataSource<T extends object> extends DikeDataSource<DikeGridDataRowEntry<T>> {

  constructor();

  get dataDeliveryChanges(): Observable<string>;
  get data(): DikeGridDataRowEntry<T>[];
  set data(value: DikeGridDataRowEntry<T>[]);
  get entries(): ReadonlyArray<T>;
  set entries(value: ReadonlyArray<T>);

  connect(): Observable<DikeGridDataRowEntry<T>[]>;
  disconnect(): void;
  reconnect(): void;
  dispose(): void;
}
```

## DikeDecoratorDataSource\<T>

```typescript
abstract class DikeDecoratorDataSource<T extends object> extends DikeDataSource<DikeGridDataRowEntry<T>> {

  constructor(
    protected dikeDataSource: DikeDataSource<DikeGridDataRowEntry<T>>);

  get data(): DikeGridDataRowEntry<T>[];
  set data(value: DikeGridDataRowEntry<T>[]);

  connect(): Observable<DikeGridDataRowEntry<T>[]>;
  disconnect(): void;
  reconnect(): void;
  dispose(): void;

  protected abstract setChangeSubscription(): void;
}

```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dikesoft.com/reference/classes/datasource.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
